﻿Imports System.IO
Imports WMPLib
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Public Class Form1
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer) ' for sleep statements
    Dim MyComPort As String
    Dim TouchFlag As Integer
    Dim ModeFlag As Integer
    Dim VideoFileName As String
    Dim DataPacket(0 To 17) As Byte ' entire data packet "Data"+14 bytes
    Dim WithEvents serialPort As New IO.Ports.SerialPort ' serial port declare
    Dim PicaxeRegisters(0 To 13) As Byte ' registers b0 to b13

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ModeFlag = 0
        Timer1.Enabled = True  ' put this in code as defaults to false when created
        Timer1.Interval = 1000 ' 1 second
        PictureBox1.BackColor = Color.Red ' set to position 'red'
        Array.Clear(PicaxeRegisters, 0, 13) ' probably not needed as array declared blank
        RichTextBox1.Text = "DIY INTERSECT CUBE"
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' timer ticks every 1 second

        Call SerialTxRx()

        ' ---- Code for Activation Sequence -----
        If (DataPacket(6)) = 0 And (DataPacket(5)) = 1 Then  ' passes thru here only once when touch switch has been on 
            PicaxeRegisters(0) = 3 ' turns LEDS and Motor to full speed on
            RichTextBox1.Text = "INTERSECT ACTIVATING ..."
            ProgressBar1.Value = 0
            Timer2.Start()
        End If

        ' ------ Code for Uploading Sequence----
        If ModeFlag = 1 Then
            ModeFlag = 0 ' reset mode flag so it does not trip a second time
            RichTextBox1.Text = "INTERSECT UPLOADING ..."
            ProgressBar1.ForeColor = Color.Green
            ProgressBar1.Value = 1
            'AxWindowsMediaPlayer1.fullScreen = True
            AxWindowsMediaPlayer1.URL = VideoFileName
            Timer3.Start()
        End If

    End Sub
    Sub SerialTxRx()
        Dim LabelString As String ' string to display byte values
        'Dim DataPacket(0 To 17) As Byte ' entire data packet "Data"+14 bytes
        Dim i As Integer ' i is always useful for loops etc
        Label1.Text = "" ' clear the text on the screen
        For i = 0 To 3
            DataPacket(i) = Asc(Mid("Data", i + 1, 1)) ' add the word "Data" to the packet
        Next
        For i = 0 To 13
            DataPacket(i + 4) = PicaxeRegisters(i) ' add all the bytes to the packet
        Next
        If serialPort.IsOpen Then
            serialPort.Close() ' just in case already opened
        End If
        Try
            With serialPort
                .PortName = MyComPort ' Most new computers default to com1 but any pre 1999 computer with a serial mouse will probably default to com2
                .BaudRate = 2400 ' 2400 is the maxiumum speed for small picaxes
                .Parity = IO.Ports.Parity.None ' no parity
                .DataBits = 8 ' 8 bits
                .StopBits = IO.Ports.StopBits.One ' one stop bit
                .ReadTimeout = 1000 ' milliseconds so times out in 1 second if no response
                .Open() ' open the serial port
                .DiscardInBuffer() ' clear the input buffer
                .Write(DataPacket, 0, 18) ' send the datapacket array
                Call Sleep(300) ' 100 milliseconds minimum to wait for data to come back and more if data stream is longer
                .Read(DataPacket, 0, 18) ' read back in the data packet array
                .Close() ' close the serial port
            End With
            For i = 4 To 17
                LabelString = LabelString + " " + Str(DataPacket(i)) ' turn into a text string
            Next
            ' -------Serial comm error handling -------------
            Label1.Text = LabelString ' put the text string on the screen
        Catch ex As Exception
            'MsgBox(ex.ToString) ' uncomment this if want to see the actual error message
            Label1.Text = "Timeout" ' will display this if picaxe not connected etc
        End Try
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        PictureBox1.BackColor = Color.Red ' change the box to red
        RichTextBox1.Text = "STOPPED"
        ProgressBar1.Value = 0
        PicaxeRegisters(0) = 0 ' sets Picaxe byte variable B0 to 0 ... this means turn off BOTH LEDS and Motor
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        PictureBox1.BackColor = Color.Green ' box to green
        RichTextBox1.Text = "MANUAL TEST RUN"
        PicaxeRegisters(0) = 2 ' sets Picaxe byte variable B0 to 2 ... means turn on LEDS and Motor (runs at medium speed)
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        ComboBox1.DropDownStyle = ComboBoxStyle.DropDownList
        'ComboBox1.SelectedIndex = 1
        MyComPort = ComboBox1.SelectedItem ' this selects the PC COM port .. COM1 , COM2 ... to be selected
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        PicaxeRegisters(0) = 1 ' sets Picaxe byte variable B0 to 1 ... means turn on LEDS and Motor @ idle speed
        PicaxeRegisters(1) = 1 ' sets Picaxe byte variable B1 to 1 ... this flags checking for touch switch activation
        RichTextBox1.Text = "DO YOU WISH TO ACTIVATE ?"
        ProgressBar1.Value = 0
        ModeFlag = 0
    End Sub
    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Timer2.Enabled = True
        Timer2.Interval = 15 ' 0.015 seconds in theory
        ProgressBar1.Style = ProgressBarStyle.Continuous
        ProgressBar1.ForeColor = Color.Green
        ProgressBar1.Increment(+1)
        If ProgressBar1.Value = 100 Then
            ProgressBar1.ForeColor = Color.Blue
            ProgressBar1.Value = 100
            RichTextBox1.Text = "Activation Complete."
            ModeFlag = 1
            Timer2.Stop()
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        OpenFileDialog1.ShowDialog()
        VideoFileName = OpenFileDialog1.FileName
    End Sub

    Private Sub Timer3_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer3.Tick
        Timer3.Interval = 100
        ProgressBar1.Style = ProgressBarStyle.Continuous
        ProgressBar1.ForeColor = Color.Green
        ProgressBar1.Increment(+1)
        If ProgressBar1.Value = 100 Then
            ProgressBar1.ForeColor = Color.Blue
            ProgressBar1.Value = 100
            RichTextBox1.Text = "Uploading Complete."
            PicaxeRegisters(0) = 1 ' sets Picaxe byte variable B0 to 1 ... this means LEDS and Motorat idel speed
            PicaxeRegisters(1) = 0 ' sets Picaxe byte variable B1 ... this unflags check for touch switch activation
            Timer3.Stop()
        End If
    End Sub

    Private Sub RichTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RichTextBox1.TextChanged
        RichTextBox1.SelectAll()
        RichTextBox1.SelectionAlignment = HorizontalAlignment.Center
    End Sub
End Class


